#include "stdafx.h"
#include "Texture.h"
#include <fstream.h>
#include "GL/glu.h"

#define FPI 3.141592653589793238462643383

//----------------------------------------
// Usefull debugger thingy.
void DebugOut(const char *szFormat, ...);
//----------------------------------------

// Change your App Name.
char szAppName[] = "Make you sick Moire Thing";

// Timer info.  Very useful for keeping animated stuff in sync on different computers.
extern float fTime, fDeltaTime;
float dTime = 0;   //  Just a little thing to fake constant framerate when dumping to AVI.

// Current window dimensions.
extern GLsizei g_w, g_h;

int frams = 0;

// Pixel Buffers...
unsigned char *pPixelData = new unsigned char[512*384*3]; 
unsigned char *pPixelData2 = new unsigned char[512*384*3]; 
ofstream file;

// CTexture gTexExample;

float SCloudx[180];
float SCloudy[180];

void fillCloud()
{
	for (int i = 0; i < 180; i++)
	{
		float fx = (float)( sin(i * (PI / 90)) );
		float fy = (float)( cos(i * (PI / 90)) );
		SCloudx[i] = fx;
		SCloudy[i] = fy;
	}
}

bool Init()	// Called right after the window is created, and OpenGL is initialized.
{
	glViewport (0, 0, (GLsizei) g_w, (GLsizei) g_h); 
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity ();
	gluPerspective(45.0f, 4.f/3.f, 0.001, 100.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glClearColor(0.0,0.0,0.0,0.0);

	glEnable( GL_TEXTURE_2D );
	glBlendFunc(GL_SRC_ALPHA, GL_ONE);
	glEnable(GL_BLEND);

	fillCloud();
	return true;
}

bool SaveSnap(int num, int quality)
{
	char fname[32];
	unsigned char *buff;
	sprintf(fname, "render\\Anm%04d.jpg",num);

	file.open(fname, ios::binary);

	int nbytes = 512 * 384 * 3;

	// Copy from OpenGL 
	// Don't forget to make OpenGL rendering context 
	// current (wglMakeCurrent)
	glReadPixels(0, 0, 512, 384, GL_RGB, GL_UNSIGNED_BYTE, pPixelData);

	// Flip the image because of GL's up = positve-y
	for (int j=0; j < 384; j ++)    // line counter
	{
		for (int i=0; i < 512;i++)  // column counter
		{
			pPixelData2[(j*512+i)*3] = pPixelData[((383-j)*512+i)*3];
			pPixelData2[(j*512+i)*3+1] = pPixelData[((383-j)*512+i)*3+1];
			pPixelData2[(j*512+i)*3+2] = pPixelData[((383-j)*512+i)*3+2];
		}
	}

	// Compressing in jpeg
	int len; // the length of the buffer after compression
	buff = (unsigned char*)Jpeg::Compress(pPixelData2, 512, 384, 3, len, quality);

	// Writing file and that's it
	file.write(buff,len); 
	file.close();

	delete buff;

	return TRUE;
}

void Shutdown() // Called right after the window is destroyed.
{
	// Cleaning memory
	delete [] pPixelData; 
	delete [] pPixelData2; 
}

void TheThing(int nr)
{
	float gx, gy;
	float bx, by;

	nr += nr;
	gx = 0.2f * sin((nr % 200) * PI / 100);
	gy = 0.25f * cos((nr % 340) * PI / 170);
	bx = 0.25f * cos((nr % 350) * PI / 175);
	by = 0.22f * sin((nr % 240) * PI / 120);
	glPushMatrix();
	glTranslatef(gx,gy,-1.f);
	glRotatef(nr % 360, 0,0,1);
	glColor4f(0,1.f,0,1.f);
	glBegin(GL_LINES);
	for (int i = 0; i < 180; i ++)
	{
		glVertex3f(0,0,0);
		glVertex3f(SCloudx[i], SCloudy[i], 0);
	}
	glEnd();
	glPopMatrix();

	glPushMatrix();
	glTranslatef(bx-gy,by-gx,-1.f);
	glColor4f(1.f,0,0,1.f);
	glBegin(GL_LINES);
	for (i = 0; i < 180; i ++)
	{
		glVertex3f(0,0,0);
		glVertex3f(SCloudx[i], SCloudy[i], 0);

	}
	glEnd();
	glPopMatrix();

	glPushMatrix();
	glTranslatef(bx-gx,by+gx,-1.f);
	glColor4f(1.0f,1.0f,0.5f,1.f);
	glBegin(GL_LINES);
	for (i = 0; i < 180; i ++)
	{
		glVertex3f(0,0,0);
		glVertex3f(SCloudx[i], SCloudy[i], 0);

	}
	glEnd();
	glPopMatrix();

	glPushMatrix();
	glTranslatef(bx,by,-1.f);
	glColor4f(0,0,1.f,1.f);
	glBegin(GL_LINES);
	for (i = 0; i < 180; i ++)
	{
		glVertex3f(0,0,0);
		glVertex3f(SCloudx[i], SCloudy[i], 0);

	}
	glEnd();
	glPopMatrix();
}

void Render()
{
	glClear( GL_COLOR_BUFFER_BIT );

	dTime += 1 / 29.97f;
	TheThing(frams);
//	SaveSnap(frams, 95);
	++frams;
}
